CREATE DATABASE BANKING_SYSTEM;

DROP TABLE IF EXISTS "USER";
DROP TABLE IF EXISTS "ACCOUNT";
DROP TABLE IF EXISTS "CARD";
DROP TABLE IF EXISTS "PSP";
DROP TABLE IF EXISTS "TRANSACTIONS";

CREATE TABLE "USER"(
	USER_ID SERIAL PRIMARY KEY,
	FIRST_NAME VARCHAR(250) NOT NULL,
	SURNAME VARCHAR(250) NOT NULL,
	ADDRESS TEXT NOT NULL,
	OCCUPATION VARCHAR(250) NOT NULL,
	CREDIT_SCORE DOUBLE PRECISION NOT NULL);

CREATE TABLE "PSP"(
	PSP_ID SERIAL PRIMARY KEY,
	PAYMENT_SERVICE_PROVIDER VARCHAR(250) NOT NULL);

CREATE TABLE "CARD"(
	CARD_NO SERIAL PRIMARY KEY,
	CVV INTEGER NOT NULL,
	PAYMENT_SERVICE_PROVIDER INTEGER NOT NULL,
	PSP_NO INTEGER REFERENCES "PSP"(PSP_ID),
	CONSTRAINT PSP_CARD UNIQUE (PSP_NO));

CREATE TABLE "TRANSACTIONS"(
	TRANSACTION_ID SERIAL PRIMARY KEY,
	ORIGIN_ACCOUNT BIGINT NOT NULL,
	DESTINATION_ACCOUNT BIGINT NOT NULL,
	TRANSACTION_DATE DATE NOT NULL,
	TRANSACTION_AMOUNT MONEY NOT NULL);

CREATE TABLE "ACCOUNT"(
	IBAN SERIAL PRIMARY KEY,
	CURRENCY VARCHAR(250) NOT NULL,
	DATE_OPENED DATE NOT NULL,
	CARD_ID INTEGER REFERENCES "CARD"(CARD_NO),
	CONSTRAINT CARD_IBAN UNIQUE (CARD_ID),
	USER_ID INTEGER REFERENCES "USER"(USER_ID),
	TRANSACTION_ID INTEGER REFERENCES "TRANSACTIONS"(TRANSACTION_ID));

INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Felicia', 'Hasdeu', 'Calea Domneasca 169, Arad', 'Asistentă Medicală', 2000);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Monica', 'Rosseti', 'Calea Cargiani 2, Deva', 'Medic', 5000);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Nic', 'Mechitbayeva', 'Strada Unirii 14b, Buzău', 'Inginer', 4000);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Nicolae', 'Mureșan', 'Strada Putul lui Zamfir 45, București', 'Designer', 4500);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Amalia', 'Saguna', 'Strada Blanari 23, Brașov', 'Programator', 3500);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Maria', 'Bogdan', 'Calea Tricolorului 123, Arad', 'Asistentă Medicală', 2200);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Monica', 'Roset', 'Calea Cargipoli 2, Deva', 'Medic', 5100);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Nic', 'Mechit', 'Strada Boerului 15, Buzău', 'Inginer', 3900);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Nicu', 'Marian', 'Strada Zamfir 55, București', 'Designer', 4400);
INSERT INTO "USER" (FIRST_NAME, SURNAME, ADDRESS, OCCUPATION, CREDIT_SCORE) VALUES ('Amalia', 'Semir', 'Strada Blanarului 25, Brașov', 'Programator', 3800);

INSERT INTO "PSP" (PAYMENT_SERVICE_PROVIDER) VALUES ('VISA');
INSERT INTO "PSP" (PAYMENT_SERVICE_PROVIDER) VALUES ('VISA ELECTRON');
INSERT INTO "PSP" (PAYMENT_SERVICE_PROVIDER) VALUES ('MASTERCARD');

INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (111, 1);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (112, 2);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (121, 3);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (211, 1);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (212, 2);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (222, 1);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (223, 2);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (321, 3);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (311, 1);
INSERT INTO "CARD" (CVV, PAYMENT_SERVICE_PROVIDER) VALUES (312, 2);


INSERT INTO "TRANSACTIONS" (ORIGIN_ACCOUNT, DESTINATION_ACCOUNT, TRANSACTION_DATE, TRANSACTION_AMOUNT) VALUES (1, 2, '2020-07-25', 1000);
INSERT INTO "TRANSACTIONS" (ORIGIN_ACCOUNT, DESTINATION_ACCOUNT, TRANSACTION_DATE, TRANSACTION_AMOUNT) VALUES (3, 4, '2021-08-20', 1200);
INSERT INTO "TRANSACTIONS" (ORIGIN_ACCOUNT, DESTINATION_ACCOUNT, TRANSACTION_DATE, TRANSACTION_AMOUNT) VALUES (5, 6, '2020-08-25', 800);
INSERT INTO "TRANSACTIONS" (ORIGIN_ACCOUNT, DESTINATION_ACCOUNT, TRANSACTION_DATE, TRANSACTION_AMOUNT) VALUES (7, 8, '2021-05-15', 900); 
INSERT INTO "TRANSACTIONS" (ORIGIN_ACCOUNT, DESTINATION_ACCOUNT, TRANSACTION_DATE, TRANSACTION_AMOUNT) VALUES (9, 10, '2020-09-05', 1500);

INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('USD', '2020-06-01', 1, 1, 1);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('USD', '2020-06-05', 2, 2, 1);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('EUR', '2021-07-11', 3, 3, 2);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('EUR', '2021-07-15', 4, 4, 2);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('GBD', '2020-07-10', 5, 5, 3);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('GBD', '2020-07-12', 6, 6, 3);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('EUR', '2021-04-12', 7, 7, 4);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('EUR', '2021-04-16', 8, 8, 4);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('USD', '2020-08-16', 9, 9, 5);
INSERT INTO "ACCOUNT" (CURRENCY, DATE_OPENED, CARD_ID, USER_ID, TRANSACTION_ID) VALUES ('USD', '2020-08-19', 10, 10, 5);

SELECT * FROM "TRANSACTIONS" ORDER BY TRANSACTION_AMOUNT DESC LIMIT 3;
SELECT A.USER_ID, U.FIRST_NAME, U.SURNAME, U.ADDRESS, U.OCCUPATION, U.CREDIT_SCORE, P.PAYMENT_SERVICE_PROVIDER FROM "PSP" P, "ACCOUNT" A INNER JOIN "CARD" C on A.CARD_ID = C.CARD_NO 
INNER JOIN "USER" U on U.USER_ID = A.USER_ID WHERE P.PAYMENT_SERVICE_PROVIDER = 'VISA' AND P.PSP_ID = C.PAYMENT_SERVICE_PROVIDER;
SELECT COUNT(*) C , CURRENCY FROM "ACCOUNT" GROUP BY CURRENCY ORDER BY C DESC;
SELECT * FROM "TRANSACTIONS" ORDER BY TRANSACTION_AMOUNT DESC LIMIT 3;
SELECT A.USER_ID, U.FIRST_NAME, U.SURNAME, U.ADDRESS, U.OCCUPATION, U.CREDIT_SCORE, P.PAYMENT_SERVICE_PROVIDER FROM "PSP" P, "ACCOUNT" A INNER JOIN "CARD" C on A.CARD_ID = C.CARD_NO 
INNER JOIN "USER" U on U.USER_ID = A.USER_ID WHERE P.PAYMENT_SERVICE_PROVIDER = 'VISA' AND P.PSP_ID = C.PAYMENT_SERVICE_PROVIDER AND U.FIRST_NAME LIKE 'S%' ORDER BY U.FIRST_NAME;
SELECT * FROM "TRANSACTIONS" WHERE TRANSACTION_DATE BETWEEN '2020-07-19' AND '2020-09-10' ORDER BY TRANSACTION_AMOUNT DESC LIMIT 3;
